<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { inject, onMounted, ref } from 'vue';
import Modal from '@/components/general/Modal.vue';
import Input from "@/components/general/form/Input.vue";
import Accordion from "@/components/general/Accordion.vue";
import AccordionItem from "@/components/general/AccordionItem.vue";
import { useChatStore } from '@/stores/chat';
import { storeToRefs } from 'pinia';
import { request } from '@/lib/request';
import CreatorExpertModeSettings from '@/components/chat/CreatorExpertModeSettings.vue';
import { useI18n } from 'vue-i18n';
import type { ChatConfig } from '@/types/chat';

const emits = defineEmits<{
    (e: 'close'): void,
    (e: 'submit', value: string | undefined): void
}>();

const { t } = useI18n();
const $t = t;

const configuration = inject<any>('configuration');
const chatStore = useChatStore();
const { state, uuid } = storeToRefs(chatStore);
const name = ref('');

const systemPrompt = ref('');

const handleSubmit = async () => {
    if (state.value === 'PERSON_CHAT_CREATE') {
        //const data = { name: name.value, systemprompt: systemPrompt.value };
        let data:ChatConfig = { name: name.value, systemprompt: systemPrompt.value };
        if(isAdditionalSettingsOpen.value){
            data.temperature = temperature.value;
            data.top_p = top_p.value;
        }
        const result = await request('PUT', configuration.apiServer + "/api/ai/chat/person/" + uuid.value, data, 'application/json', undefined, true);
        if (result.success) {
            emits('submit', result.uuid);
        }
    }
};

onMounted(async () => {
    if (state.value === 'PERSON_CHAT_CREATE' && uuid.value) {
        const result = await request('GET', configuration.apiServer + "/api/ai/person/" + uuid.value, undefined, 'application/json', undefined, true);
        if (result.success) {
            systemPrompt.value = result.person.system_prompt;
        }
    }
});

const handleCancel = () => {
    emits('close');
};

const isAccordionOpen = ref(false);
const handleOpenAccordion = () => {
    isAccordionOpen.value = !isAccordionOpen.value;
};

const isAdditionalSettingsOpen = ref(false);

const defaultPreset =  { "name": "default", "label": $t('ai.general.variables.expertMode.preset.default.label'), "description": $t('ai.general.variables.expertMode.preset.default.description'), "temp": 1, "top_p": 1};
const presets = [defaultPreset, ...configuration.ai.chatPresets];
const temperature = ref(presets[0].temp);
const top_p = ref(presets[0].top_p);

</script>
<template>
    <Modal :header="$t('ai.chat.create.create.label')" @submit="handleSubmit" :labelSubmit="$t('general.buttons.save')"
        :disableSubmit="name.length === 0" :labelCancel="$t('general.buttons.cancel')" @cancel="handleCancel">
        <Input v-model="name" :label="$t('ai.chat.create.name.label')" type="text"
            :placeholder="$t('ai.chat.create.name.placeholder')" />
        <Accordion v-if="state === 'PERSON_CHAT_CREATE'">
            <AccordionItem :header="$t('ai.chat.create.additionalFields.header')" :height="210"
                @click="handleOpenAccordion" :active="isAccordionOpen">
                <div class="flex flex-col gap-1">
                    <label class="flex flex-row gap-2">{{ $t('ai.chat.create.systemprompt.label') }}<Tooltip
                            :tooltip="$t('ai.person.chat.systemPrompt.tooltip')"><i
                                class="ri-information-2-line cursor-pointer"></i></Tooltip></label>
                    <textarea
                        class="border border-gray-300 rounded-md resize-none p-2 text-gray-500 focus:outline-none focus-within:outline-none"
                        maxlength="4000" rows="6" v-model="systemPrompt"
                        :placeholder="$t('ai.chat.create.systemprompt.placeholder')"></textarea>
                    <div class="text-right text-gray-500"> {{ systemPrompt.length }} / 4000</div>
                </div>
                <CreatorExpertModeSettings v-model:open="isAdditionalSettingsOpen" v-model:temperature="temperature" v-model:top_p="top_p" :presets="presets"/>
            </AccordionItem>
        </Accordion>
    </Modal>
</template>